/*
 * Copyright (c) 2015 Tricoire Sebastien 3dsman@free.fr
 *
 * This software is provided 'as-is', without any express or implied
 * warranty.  In no event will the authors be held liable for any damages
 * arising from the use of this software.
 *
 * Permission is granted to anyone to use this software for any purpose,
 * including commercial applications, and to alter it and redistribute it
 * freely, subject to the following restrictions:
 *
 * 1. The origin of this software must not be misrepresented; you must not
 * claim that you wrote the original software. If you use this software
 * in a product, an acknowledgment in the product documentation would be
 * appreciated but is not required.
 * 2. Altered source versions must be plainly marked as such, and must not be
 * misrepresented as being the original software.
 * 3. This notice may not be removed or altered from any source distribution.
 *
 */

#ifndef OE_COMMANDDISPLAY_H
#define OE_COMMANDDISPLAY_H

#include "OE_display.h"
#include <GLFW/glfw3.h>

class OE_commandDisplay : public OE_display
{
public:
	
		
        /** Default constructor */
        OE_commandDisplay();
		OE_commandDisplay(OE_document* document,OE_controller* controller);
        /** Default destructor */
        virtual ~OE_commandDisplay();
		
		virtual void key(int key, int scancode, int action, int mods);
		
		bool draw();
		//bool forceRefresh = true;

    protected:
    private:

		/** \brief color of the stitch line	 */
        static  unsigned char lineColor[4] ;

		/** \brief color of the commands	 */
        static unsigned char commandColor[4] ;
		
		/** \brief color of the start point	 */
        static unsigned char startPointColor[4] ;
		
		/** \brief color of the current point	 */
        static unsigned char curPointColor[4] ;
		
		/** \brief draw the instruction	 */
		bool drawInstPoints();
		
		bool run = 0;
		
};

#endif // OE_EDITDISPLAY_H
