/*
 * Copyright (c) 2015 Tricoire Sebastien 3dsman@free.fr
 *
 * This software is provided 'as-is', without any express or implied
 * warranty.  In no event will the authors be held liable for any damages
 * arising from the use of this software.
 *
 * Permission is granted to anyone to use this software for any purpose,
 * including commercial applications, and to alter it and redistribute it
 * freely, subject to the following restrictions:
 *
 * 1. The origin of this software must not be misrepresented; you must not
 * claim that you wrote the original software. If you use this software
 * in a product, an acknowledgment in the product documentation would be
 * appreciated but is not required.
 * 2. Altered source versions must be plainly marked as such, and must not be
 * misrepresented as being the original software.
 * 3. This notice may not be removed or altered from any source distribution.
 *
 */

#ifndef OE_ACTIONSLINESTITCHS_H
#define OE_ACTIONSLINESTITCHS_H


#include "actions/OE_actions.h"

class OE_actionNewLineStitch : public OE_actions
{
    public:
        OE_actionNewLineStitch(float len, float width, unsigned motif, float offset);

        virtual ~OE_actionNewLineStitch();

        virtual void undo();

        virtual void redo();
    protected:
        OE_actions* action = 0;
        OE_linestitch* linestitch = 0;
};

class OE_actionSetLineStitchMotif : public OE_actions
{
    public:
        OE_actionSetLineStitchMotif(OE_linestitch* stitch, unsigned motif);

        virtual ~OE_actionSetLineStitchMotif();

        virtual void undo();

        virtual void redo();
    protected:
        OE_linestitch* actionStitch = 0;
        unsigned oldMotif;
};
/*
class OE_actionSetLineStitchCurve : public OE_actions
{
    public:
        OE_actionSetLineStitchCurve(OE_linestitch* stitch, OE_curve * curve);

        virtual ~OE_actionSetLineStitchCurve();

        virtual void undo();

        virtual void redo();
    protected:
        OE_linestitch* actionStitch = 0;
        OE_curve * oldCurve = 0;
};
*/
class OE_actionSetLineStitchLen : public OE_actions
{
    public:
        OE_actionSetLineStitchLen(OE_linestitch* stitch, float len);

        virtual ~OE_actionSetLineStitchLen();

        virtual void undo();

        virtual void redo();
    protected:
        OE_linestitch* actionStitch = 0;
        float oldLen;
};

class OE_actionSetLineStitchWidth : public OE_actions
{
    public:
        OE_actionSetLineStitchWidth(OE_linestitch* stitch, float width);

        virtual ~OE_actionSetLineStitchWidth();

        virtual void undo();

        virtual void redo();
    protected:
        OE_linestitch* actionStitch = 0;
        float oldWidth;
};

class OE_actionSetLineStitchReverse : public OE_actions
{
    public:
        OE_actionSetLineStitchReverse(OE_linestitch* stitch, bool reverse);

        virtual ~OE_actionSetLineStitchReverse();

        virtual void undo();

        virtual void redo();
    protected:
        OE_linestitch* actionStitch = 0;
        bool oldReverse;
};

#endif // OE_ACTIONSLINESTITCHS_H
